import { Observable } from 'rxjs';
import { map } from 'rxjs/operators';
import { CallHandler, ExecutionContext, Injectable, NestInterceptor } from '@nestjs/common';

import { ResourceType } from '../types/resource.type';
import { Serializable } from '../interfaces/serializable.interface';

export interface ResourceSerializerOptions<T extends Serializable> {
  type: ResourceType<T>;
}

@Injectable()
export class ResourceSerializerInterceptor<T extends Serializable> implements NestInterceptor<T, T> {
  constructor(private options: ResourceSerializerOptions<T>) { }

  public intercept(context: ExecutionContext, next: CallHandler): Observable<T> {
    return next.handle().pipe(map(data => { 
      return data;
    }));
  }
}